=== modified file 'Makefile'
--- Makefile	2009-01-15 04:55:10 +0000
+++ Makefile	2009-01-17 02:12:05 +0000
@@ -16,7 +16,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.4
+version=1.0.5
 SED=sed
 
 ## Use these settings for a traditional /usr/local install

=== modified file 'NEWS'
--- NEWS	2009-01-15 04:55:10 +0000
+++ NEWS	2009-01-17 02:12:05 +0000
@@ -1,6 +1,10 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.0.5 (2009-01-17)
+* Client
+** Fix small memory leak in plugin-runner.
+
 Version 1.0.4 (2009-01-15)
 * Server
 ** Only find matched user/group pairs when searching for suitable

=== modified file 'TODO'
--- TODO	2009-01-12 22:02:33 +0000
+++ TODO	2009-01-19 05:56:10 +0000
@@ -1,9 +1,6 @@
 -*- org -*-
 
 * mandos-client
-** TODO [#B] Temporarily lower kernel log level
-   for less printouts during sucessfull boot.
-   klogctl(6, NULL, 0); klogctl(7, NULL, 0);
 ** TODO [#C] IPv4 support
 
 * plugin-runner
@@ -41,13 +38,11 @@
 * mandos-list
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Disable client
-** TODO Enable client
-** TODO Reset timer
 
 * Curses interface
 
 * mandos-keygen
+** TODO Loop until passwords match when run interactively
 ** TODO "--secfile" option
    Using the "secfile" option instead of "secret"
 ** TODO [#B] "--test" option

=== modified file 'debian/changelog'
--- debian/changelog	2009-01-15 04:55:10 +0000
+++ debian/changelog	2009-01-17 02:12:05 +0000
@@ -1,3 +1,9 @@
+mandos (1.0.5-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sat, 17 Jan 2009 02:26:00 +0100
+
 mandos (1.0.4-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'mandos'
--- mandos	2009-01-15 04:55:10 +0000
+++ mandos	2009-01-17 02:34:57 +0000
@@ -66,7 +66,7 @@
 import ctypes
 import ctypes.util
 
-version = "1.0.4"
+version = "1.0.5"
 
 logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
@@ -911,7 +911,8 @@
                       " files")
     parser.add_option("--no-dbus", action="store_false",
                       dest="use_dbus",
-                      help=optparse.SUPPRESS_HELP) # XXX: Not done yet
+                      help="Do not provide D-Bus system bus"
+                      " interface")
     options = parser.parse_args()[0]
     
     if options.check:
@@ -957,7 +958,6 @@
     # For convenience
     debug = server_settings["debug"]
     use_dbus = server_settings["use_dbus"]
-    use_dbus = False            # XXX: Not done yet
     
     if not debug:
         syslogger.setLevel(logging.WARNING)

=== modified file 'mandos-ctl' (properties changed: -x to +x)
--- mandos-ctl	2009-01-15 04:55:10 +0000
+++ mandos-ctl	2009-01-19 05:56:10 +0000
@@ -30,7 +30,7 @@
 server_path = '/Mandos'
 server_interface = 'org.mandos_system.Mandos'
 client_interface = 'org.mandos_system.Mandos.Client'
-version = "1.0.4"
+version = "1.0.5"
 
 bus = dbus.SystemBus()
 mandos_dbus_objc = bus.get_object(busname, server_path)
@@ -124,8 +124,10 @@
                   help="Start checker for specified client")
 parser.add_option("--stop-checker", action="store_true",
                   help="Stop checker for specified client")
-parser.add_option("-v", "--is-valid", action="store_true",
-                  help="Stop checker for specified client")
+parser.add_option("-V", "--is-valid", action="store_true",
+                  help="Check if specified client is still valid")
+parser.add_option("-Q", "--quit", action="store_true",
+                  help="Stops the running mandos server")
 parser.add_option("-c", "--checker", type="string",
                   help="Set checker command for specified client")
 parser.add_option("-t", "--timeout", type="string",

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-01-15 04:55:10 +0000
+++ mandos-keygen	2009-01-17 09:46:54 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.4"
+VERSION="1.0.5"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -147,7 +147,7 @@
 	echo "Invalid key length" >&2
 	exit 1
     fi
-
+    
     if [ -z "$KEYEXPIRE" ]; then
 	echo "Empty key expiration" >&2
 	exit 1
@@ -172,7 +172,7 @@
     if [ -n "$KEYEMAIL" ]; then
 	KEYEMAILLINE="Name-Email: $KEYEMAIL"
     fi
-
+    
     # Create temporary gpg batch file
     BATCHFILE="`mktemp -t mandos-keygen-batch.XXXXXXXXXX`"
 fi
@@ -284,7 +284,7 @@
 	stty echo
 	if [ "$first" != "$second" ]; then
 	    echo -e "Passphrase mismatch" >&2
-	    false
+	    touch "$RINGDIR"/mismatch
 	else
 	    echo -n "$first"
 	fi
@@ -292,9 +292,9 @@
 	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
 	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
 	> "$SECFILE"
-    status="${PIPESTATUS[0]}"
-    if [ "$status" -ne 0 ]; then
-	exit "$status"
+    if [ -e "$RINGDIR"/mismatch ]; then
+	rm --force "$RINGDIR"/mismatch
+	exit 1
     fi
     
     cat <<-EOF

=== modified file 'mandos.lsm'
--- mandos.lsm	2009-01-15 04:55:10 +0000
+++ mandos.lsm	2009-01-17 02:12:05 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.0.4
-Entered-date:	2009-01-15
+Version:	1.0.5
+Entered-date:	2009-01-17
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      94K mandos_1.0.4.orig.tar.gz
+	      94K mandos_1.0.5.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		94K mandos_1.0.4.orig.tar.gz
+		94K mandos_1.0.5.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.4, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2009-01-05 23:26:06 +0000
+++ mandos.xml	2009-01-15 05:27:55 +0000
@@ -85,6 +85,8 @@
       <replaceable>DIRECTORY</replaceable></option></arg>
       <sbr/>
       <arg><option>--debug</option></arg>
+      <sbr/>
+      <arg><option>--no-dbus</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -229,6 +231,16 @@
 	  </para>
 	</listitem>
       </varlistentry>
+      
+      <varlistentry>
+	<term><option>--no-dbus</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="dbus"/>
+	  <para>
+	    See also <xref linkend="dbus_interface"/>.
+	  </para>
+	</listitem>
+      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -324,6 +336,16 @@
     </para>
   </refsect1>
   
+  <refsect1 id="dbus_interface">
+    <title>D-BUS INTERFACE</title>
+    <para>
+      The server will by default provide a D-Bus system bus interface.
+      This interface will only be accessible by the root user or a
+      Mandos-specific user, if such a user exists.
+      <!-- XXX -->
+    </para>
+  </refsect1>
+
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2009-01-14 14:20:17 +0000
+++ plugin-runner.c	2009-01-17 02:34:57 +0000
@@ -115,6 +115,7 @@
   if(name != NULL){
     copy_name = strdup(name);
     if(copy_name == NULL){
+      free(new_plugin);
       return NULL;
     }
   }

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2009-01-14 14:20:17 +0000
+++ plugins.d/mandos-client.c	2009-01-17 12:12:26 +0000
@@ -60,7 +60,7 @@
 #include <inttypes.h>		/* PRIu16, intmax_t, SCNdMAX */
 #include <assert.h>		/* assert() */
 #include <errno.h>		/* perror(), errno */
-#include <time.h>		/* time() */
+#include <time.h>		/* time(), nanosleep() */
 #include <net/if.h>		/* ioctl, ifreq, SIOCGIFFLAGS, IFF_UP,
 				   SIOCSIFFLAGS, if_indextoname(),
 				   if_nametoindex(), IF_NAMESIZE */
@@ -74,6 +74,7 @@
 				   argp_state, struct argp,
 				   argp_parse(), ARGP_KEY_ARG,
 				   ARGP_KEY_END, ARGP_ERR_UNKNOWN */
+#include <sys/klog.h> 		/* klogctl() */
 
 /* Avahi */
 /* All Avahi types, constants and functions
@@ -840,6 +841,7 @@
 			  ":!CTYPE-X.509:+CTYPE-OPENPGP" };
     bool gnutls_initalized = false;
     bool gpgme_initalized = false;
+    double delay = 2.5;
     
     {
       struct argp_option options[] = {
@@ -871,6 +873,10 @@
 	  .arg = "STRING",
 	  .doc = "GnuTLS priority string for the TLS handshake",
 	  .group = 1 },
+	{ .name = "delay", .key = 131,
+	  .arg = "SECONDS",
+	  .doc = "Maximum delay to wait for interface startup",
+	  .group = 2 },
 	{ .name = NULL }
       };
       
@@ -904,6 +910,13 @@
 	case 130:		/* --priority */
 	  mc.priority = arg;
 	  break;
+	case 131:		/* --delay */
+	  ret = sscanf(arg, "%lf%n", &delay, &numchars);
+	  if(ret < 1 or arg[numchars] != '\0'){
+	    fprintf(stderr, "Bad delay\n");
+	    exit(EXIT_FAILURE);
+	  }
+	  break;
 	case ARGP_KEY_ARG:
 	  argp_usage(state);
 	case ARGP_KEY_END:
@@ -928,16 +941,31 @@
     
     /* If the interface is down, bring it up */
     {
+      // Lower kernel loglevel to KERN_NOTICE to avoid
+      // KERN_INFO messages to mess up the prompt
+      ret = klogctl(8, NULL, 5);
+      if(ret == -1){
+	perror("klogctl");
+      }
+
       sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
       if(sd < 0) {
 	perror("socket");
 	exitcode = EXIT_FAILURE;
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror("klogctl");
+	}
 	goto end;
       }
       strcpy(network.ifr_name, interface);
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
 	perror("ioctl SIOCGIFFLAGS");
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror("klogctl");
+	}
 	exitcode = EXIT_FAILURE;
 	goto end;
       }
@@ -947,13 +975,33 @@
 	if(ret == -1){
 	  perror("ioctl SIOCSIFFLAGS");
 	  exitcode = EXIT_FAILURE;
+	  ret = klogctl(7, NULL, 0);
+	  if(ret == -1){
+	    perror("klogctl");
+	  }
 	  goto end;
 	}
       }
+      // sleep checking until interface is running
+      for(int i=0; i < delay * 4; i++){
+	ret = ioctl(sd, SIOCGIFFLAGS, &network);
+	if(ret == -1){
+	  perror("ioctl SIOCGIFFLAGS");
+	} else if(network.ifr_flags & IFF_RUNNING){
+	  break;
+	}
+	struct timespec sleeptime = { .tv_nsec = 250000000 };
+	nanosleep(&sleeptime, NULL);
+      }
       ret = (int)TEMP_FAILURE_RETRY(close(sd));
       if(ret == -1){
 	perror("close");
       }
+      // Restores kernel loglevel to default
+      ret = klogctl(7, NULL, 0);
+      if(ret == -1){
+	perror("klogctl");
+      }
     }
     
     uid = getuid();
@@ -1086,7 +1134,7 @@
     if(debug){
       fprintf(stderr, "Starting Avahi loop search\n");
     }
-    
+
     avahi_simple_poll_loop(mc.simple_poll);
     
  end:

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/mandos-client.xml	2009-01-17 12:12:26 +0000
@@ -93,6 +93,10 @@
       </arg>
       <sbr/>
       <arg>
+	<option>--delay <replaceable>SECONDS</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -251,6 +255,22 @@
 	  </para>
 	</listitem>
       </varlistentry>
+
+      <varlistentry>
+	<term><option>--delay=<replaceable
+	>SECONDS</replaceable></option></term>
+	<listitem>
+	  <para>
+	    After bringing the network interface up, the program waits
+	    for the interface to arrive in a <quote>running</quote>
+	    state before proceeding.  During this time, the kernel log
+	    level will be lowered to reduce clutter on the system
+	    console, alleviating any other plugins which might be
+	    using the system console.  This option sets the upper
+	    limit of seconds to wait.  The default is 2.5 seconds.
+	  </para>
+	</listitem>
+      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2009-01-13 04:35:19 +0000
+++ plugins.d/password-prompt.c	2009-01-17 12:12:26 +0000
@@ -194,7 +194,7 @@
       const char *cryptsource = getenv("cryptsource");
       const char *crypttarget = getenv("crypttarget");
       const char *const prompt
-	= "Enter passphrase to unlock the disk";
+	= "Enter passphrase to unlock the disk";      
       if(cryptsource == NULL){
 	if(crypttarget == NULL){
 	  fprintf(stderr, "%s: ", prompt);

